package org.springframework.web.servlet.view.json.writer.xstream;

import org.springframework.validation.BindingResult;
import org.springframework.web.servlet.view.json.writer.xstream.core.PropertyEditorRegistryConverterLookup;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.alias.ClassMapper;
import com.thoughtworks.xstream.converters.ConverterRegistry;
import com.thoughtworks.xstream.converters.reflection.ReflectionProvider;
import com.thoughtworks.xstream.io.HierarchicalStreamDriver;
import com.thoughtworks.xstream.mapper.Mapper;

public class SpringJsonXStream extends XStream {
	protected SpringJsonXStream() {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	protected SpringJsonXStream(ReflectionProvider reflectionProvider,
			HierarchicalStreamDriver driver, ClassLoader classLoader,
			Mapper mapper, PropertyEditorRegistryConverterLookup converterLookup,
			ConverterRegistry converterRegistry) {
		super(reflectionProvider, driver, classLoader, mapper, converterLookup,
				converterRegistry);
	}

	protected SpringJsonXStream(ReflectionProvider reflectionProvider) {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	protected SpringJsonXStream(
			HierarchicalStreamDriver hierarchicalStreamDriver) {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	protected SpringJsonXStream(ReflectionProvider reflectionProvider,
			HierarchicalStreamDriver hierarchicalStreamDriver) {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	protected SpringJsonXStream(ReflectionProvider reflectionProvider,
			ClassMapper classMapper, HierarchicalStreamDriver driver) {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	protected SpringJsonXStream(ReflectionProvider reflectionProvider,
			ClassMapper classMapper, HierarchicalStreamDriver driver,
			String classAttributeIdentifier) {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	protected SpringJsonXStream(ReflectionProvider reflectionProvider,
			Mapper mapper, HierarchicalStreamDriver driver) {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	protected SpringJsonXStream(ReflectionProvider reflectionProvider,
			HierarchicalStreamDriver driver, ClassLoader classLoader) {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	protected SpringJsonXStream(ReflectionProvider reflectionProvider,
			HierarchicalStreamDriver driver, ClassLoader classLoader,
			Mapper mapper) {
		throw new UnsupportedOperationException(
				"This constructors is not supported! Please use the SpringJsonXStreamBuilder.");
	}

	public void setBindingResult(BindingResult bindingResult) {
		((PropertyEditorRegistryConverterLookup) getConverterLookup())
				.setBindingResult(bindingResult);
	}

	public BindingResult getBindingResult() {
		return ((PropertyEditorRegistryConverterLookup) getConverterLookup())
				.getBindingResult();
	}
}
