package org.springframework.web.servlet.view.json.writer.xstream.converter;

import java.beans.PropertyEditor;

import org.springframework.web.servlet.view.json.writer.xstream.io.SpringJsonHierarchicalStreamWriterHelper;

import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.ExtendedHierarchicalStreamWriterHelper;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;


public class CustomEditorConverter implements Converter{
	private PropertyEditor pe;
	
	
	public CustomEditorConverter(PropertyEditor pe) {
		this.pe = pe;
	}

	public void marshal(Object source, HierarchicalStreamWriter writer,
			MarshallingContext context) {
		
		pe.setValue(source);
		SpringJsonHierarchicalStreamWriterHelper.setValue(writer, pe.getAsText(), true);	
	}

	public Object unmarshal(HierarchicalStreamReader reader, UnmarshallingContext context) {
		throw new UnsupportedOperationException("No Json Unmarshalling supported!");
	}

	public boolean canConvert(Class type) { 
		 return  true;
	}
	 
}
